<?php

//
// 2005 Bernhard Vogl (http://dativ.at)
// 2016 Erik KRause
// This software is intended as an expansion of Erik Krause's "qtkrparse" package 3.0
// See: http://www.erik-krause.de/qtkrparse
//
//
// Usage:
// http://YOUR_URL/convert2.php?file=NAME_OF_HTMFILE[&pos=QTVR_TRACK_POSITION]
// pos: defaults to 1 if not specified

// Get input parameters
$file = (array_key_exists("file", $_GET)) ? $_GET["file"] : "";
$want_pos = (array_key_exists("pos", $_GET)) ? $_GET["pos"] : 1;

$path=dirname($_SERVER['REQUEST_URI']);
chdir($_SERVER['DOCUMENT_ROOT'].$path);
if (!file_exists($file)) {
        exit ("Convert: No input file, file not found or illegal method: ".$file);
};


// Read File in Memory
$filePointer=fOpen($file,"r");
$fileContents=fRead($filePointer, fileSize($file));

// Call the Parser
$htm_out=dig_html ("", $fileContents, "", "", "", $want_pos, 1);

// This modification only needed for modified qtparser
$tempfilear = explode('.', basename($htm_out[2], 2));
$movfile = array_shift($tempfilear).".mov";
// Generate modified HTML Page

// "left" part
echo $htm_out[0];
?>
<div id="krpano" style="width:99%;height:91%;">
        <noscript><table width="100%" height="100%"><tr valign="middle"><td><center>ERROR:<br><br>Javascript not activated<br><br></center></td></tr></table></noscript>
</div>
<script src="/krpano.js"></script>
<script>
  embedpano({swf:"krpano.swf", xml:"qtkrparse.php?mov=<?php echo $movfile ?>", target:"krpano", html5:"auto"});
</script>

<?php
// "right" part
echo $htm_out[1];
exit;

// This function will strip the <object> tag from the input page
// and extract movie file and plugin dimensions
// Parameters (in/out): (already searched part, part to search, (out:) movie file name,
// (out:) width, (out:) heigth, (in:) position of object), (in/out:) parsed positions)
function dig_html ($processed, $infile, $mov, $w, $h, $want_pos, $pos) {
  if ($infile=="") {
    echo "Convert: Parsing error: no matching object found!</br>";
    echo "Check input file and parameters!";
    exit;
  }
  $pieces=explode("<",$infile,2);
  $left=$pieces[0];
  $found_object=false;
  // Code for checking correct position begin
  if ((strpos(strtolower($pieces[1]), "object")!==false) and (strpos(strtolower($pieces[1]), "object") < 5)){
    $found_object=true;
  }
  if ($pos < $want_pos) {
    $pos++;
    $found_object=false;
    $pieces=explode("/object",$infile,2);
  }
  // Code for checking correct position end
  if ($found_object==true) {
    $mov=getTagval (stristr ($pieces[1], "src"), "value");
    $w=getTagval ($pieces[1], "width");
    $h=getTagval ($pieces[1], "height");
    $left=$processed.$pieces[0];
    $right=substr (stristr(stristr($pieces[1], "/object"),">"),1);
  } else {
    list ($left,$right)=explode(">", $pieces[1],2);
    $left=$pieces[0]."<".$left.">";
    list ($left, $right, $mov, $w, $h, $want_pos, $pos)=dig_html ($processed.$left, $right, $mov, $w, $h, $want_pos, $pos);
  }
  return array ($left, $right, $mov, $w, $h, $want_pos, $pos);
}

// Helper for extracting tag values
// Parameters(in): code fragment to search, tag name
//          (out): tag value
function getTagval ($instring, $tag) {
  $pattern='[=|"| ]';
  $otag=preg_split ($pattern, stristr(stristr ($instring, $tag), "="), -1, PREG_SPLIT_NO_EMPTY);
  foreach ($otag as $element) {
    if ( !preg_match($pattern, $element) ) {
      $w=$element;
      break;
    }
  }
  return $element;
}

?>